/*

 Copyright (c) 2013, Ken Anderson <caffeinatedrat at gmail dot com>
 All rights reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright
       notice, this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE AUTHOR AND CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 -----------------------------------------------------------------
 Required Libraries:
 1) Three.js
 -----------------------------------------------------------------

 -----------------------------------------------------------------
 Change Log
 Version 2 (3/9/13) --  Added an exception for browsers that do not support webgl.
 Version 3 (3/14/13) --  Fixed the stop method so it calls the cancelAnimationFrame rather than clearTimeout.
 Version 4 (5/5/13) --  Added functionality to the property positionVector3, so that now models will be translated to that position.
 Version 5 (6/23/13) -- Added an arm motion animation, and some head motion.

 Version 6 (7/7/13)
 1) Started using the CaffeinatedRat namespace and crlib library and a new version object.
 2) Changed the way the prototype methods are written.
 -----------------------------------------------------------------
*/
var CaffeinatedRat=CaffeinatedRat||{};CaffeinatedRat.Minecraft=CaffeinatedRat.Minecraft||{};CaffeinatedRat.Minecraft.ComputedModel=function(a){a=a||{};this._skinImage=void 0!==a.skinImage?a.skinImage:null;void 0!==a.hideHelmet?this._hideHelment=a.hideHelmet:this._hideHelmet=!1;this._scale=void 0!==a.scale?a.scale:300;this._positionVector3=void 0!==a.positionVector3?a.positionVector3:new THREE.Vector3(0,0,0);this._playerModel=this._headGroup=this._leftArmMesh=this._rightArmMesh=this._helmetMesh=null};
CaffeinatedRat.Minecraft.ComputedModel.prototype={constructor:CaffeinatedRat.Minecraft.ComputedModel,init:function(a){if(void 0===a)throw new CaffeinatedRat.Minecraft.ComputedModel.SceneNotDefinedException("constructor");this._scene=a;var e=new THREE.Texture(this._skinImage);e.magFilter=THREE.NearestFilter;e.minFilter=THREE.NearestFilter;e.needsUpdate=!0;var b=new THREE.CubeGeometry(this._scale,this._scale,this._scale);b.faceVertexUvs[0][1][0]=new THREE.Vector2(0,0.75);b.faceVertexUvs[0][1][1]=new THREE.Vector2(0,
0.5);b.faceVertexUvs[0][1][2]=new THREE.Vector2(0.125,0.5);b.faceVertexUvs[0][1][3]=new THREE.Vector2(0.125,0.75);b.faceVertexUvs[0][4][0]=new THREE.Vector2(0.125,0.75);b.faceVertexUvs[0][4][1]=new THREE.Vector2(0.125,0.5);b.faceVertexUvs[0][4][2]=new THREE.Vector2(0.25,0.5);b.faceVertexUvs[0][4][3]=new THREE.Vector2(0.25,0.75);b.faceVertexUvs[0][0][0]=new THREE.Vector2(0.25,0.75);b.faceVertexUvs[0][0][1]=new THREE.Vector2(0.25,0.5);b.faceVertexUvs[0][0][2]=new THREE.Vector2(0.375,0.5);b.faceVertexUvs[0][0][3]=
new THREE.Vector2(0.375,0.75);b.faceVertexUvs[0][5][0]=new THREE.Vector2(0.375,0.75);b.faceVertexUvs[0][5][1]=new THREE.Vector2(0.375,0.5);b.faceVertexUvs[0][5][2]=new THREE.Vector2(0.5,0.5);b.faceVertexUvs[0][5][3]=new THREE.Vector2(0.5,0.75);b.faceVertexUvs[0][2][0]=new THREE.Vector2(0.125,1);b.faceVertexUvs[0][2][1]=new THREE.Vector2(0.125,0.75);b.faceVertexUvs[0][2][2]=new THREE.Vector2(0.25,0.75);b.faceVertexUvs[0][2][3]=new THREE.Vector2(0.25,1);b.faceVertexUvs[0][3][0]=new THREE.Vector2(0.25,
0.75);b.faceVertexUvs[0][3][1]=new THREE.Vector2(0.25,1);b.faceVertexUvs[0][3][2]=new THREE.Vector2(0.375,1);b.faceVertexUvs[0][3][3]=new THREE.Vector2(0.375,0.75);var d=new THREE.CubeGeometry(1.125*this._scale,1.125*this._scale,1.125*this._scale);d.faceVertexUvs[0][1][0]=new THREE.Vector2(0.5,0.75);d.faceVertexUvs[0][1][1]=new THREE.Vector2(0.5,0.5);d.faceVertexUvs[0][1][2]=new THREE.Vector2(0.625,0.5);d.faceVertexUvs[0][1][3]=new THREE.Vector2(0.625,0.75);d.faceVertexUvs[0][4][0]=new THREE.Vector2(0.625,
0.75);d.faceVertexUvs[0][4][1]=new THREE.Vector2(0.625,0.5);d.faceVertexUvs[0][4][2]=new THREE.Vector2(0.75,0.5);d.faceVertexUvs[0][4][3]=new THREE.Vector2(0.75,0.75);d.faceVertexUvs[0][0][0]=new THREE.Vector2(0.75,0.75);d.faceVertexUvs[0][0][1]=new THREE.Vector2(0.75,0.5);d.faceVertexUvs[0][0][2]=new THREE.Vector2(0.875,0.5);d.faceVertexUvs[0][0][3]=new THREE.Vector2(0.875,0.75);d.faceVertexUvs[0][5][0]=new THREE.Vector2(0.875,0.75);d.faceVertexUvs[0][5][1]=new THREE.Vector2(0.875,0.5);d.faceVertexUvs[0][5][2]=
new THREE.Vector2(1,0.5);d.faceVertexUvs[0][5][3]=new THREE.Vector2(1,0.75);d.faceVertexUvs[0][2][0]=new THREE.Vector2(0.625,1);d.faceVertexUvs[0][2][1]=new THREE.Vector2(0.625,0.75);d.faceVertexUvs[0][2][2]=new THREE.Vector2(0.75,0.75);d.faceVertexUvs[0][2][3]=new THREE.Vector2(0.75,1);d.faceVertexUvs[0][3][0]=new THREE.Vector2(0.75,1);d.faceVertexUvs[0][3][1]=new THREE.Vector2(0.75,0.75);d.faceVertexUvs[0][3][2]=new THREE.Vector2(0.875,0.75);d.faceVertexUvs[0][3][3]=new THREE.Vector2(0.875,1);var f=
new THREE.CubeGeometry(this._scale,1.5*this._scale,0.5*this._scale);f.faceVertexUvs[0][1][0]=new THREE.Vector2(0.25,0.375);f.faceVertexUvs[0][1][1]=new THREE.Vector2(0.25,0);f.faceVertexUvs[0][1][2]=new THREE.Vector2(0.3125,0);f.faceVertexUvs[0][1][3]=new THREE.Vector2(0.3125,0.375);f.faceVertexUvs[0][4][0]=new THREE.Vector2(0.3125,0.375);f.faceVertexUvs[0][4][1]=new THREE.Vector2(0.3125,0);f.faceVertexUvs[0][4][2]=new THREE.Vector2(0.4375,0);f.faceVertexUvs[0][4][3]=new THREE.Vector2(0.4375,0.375);
f.faceVertexUvs[0][0][0]=new THREE.Vector2(0.4375,0.375);f.faceVertexUvs[0][0][1]=new THREE.Vector2(0.4375,0);f.faceVertexUvs[0][0][2]=new THREE.Vector2(0.5,0);f.faceVertexUvs[0][0][3]=new THREE.Vector2(0.5,0.375);f.faceVertexUvs[0][5][0]=new THREE.Vector2(0.5,0.375);f.faceVertexUvs[0][5][1]=new THREE.Vector2(0.5,0);f.faceVertexUvs[0][5][2]=new THREE.Vector2(0.625,0);f.faceVertexUvs[0][5][3]=new THREE.Vector2(0.625,0.375);f.faceVertexUvs[0][2][0]=new THREE.Vector2(0.3125,0.375);f.faceVertexUvs[0][2][1]=
new THREE.Vector2(0.3125,0.5);f.faceVertexUvs[0][2][2]=new THREE.Vector2(0.4375,0.5);f.faceVertexUvs[0][2][3]=new THREE.Vector2(0.4375,0.375);f.faceVertexUvs[0][3][0]=new THREE.Vector2(0.4375,0.375);f.faceVertexUvs[0][3][1]=new THREE.Vector2(0.4375,0.5);f.faceVertexUvs[0][3][2]=new THREE.Vector2(0.5625,0.5);f.faceVertexUvs[0][3][3]=new THREE.Vector2(0.5625,0.375);var c=new THREE.CubeGeometry(0.5*this._scale,1.5*this._scale,0.5*this._scale);c.faceVertexUvs[0][1][0]=new THREE.Vector2(0.625,0.375);c.faceVertexUvs[0][1][1]=
new THREE.Vector2(0.625,0);c.faceVertexUvs[0][1][2]=new THREE.Vector2(0.6875,0);c.faceVertexUvs[0][1][3]=new THREE.Vector2(0.6875,0.375);c.faceVertexUvs[0][4][0]=new THREE.Vector2(0.6875,0.375);c.faceVertexUvs[0][4][1]=new THREE.Vector2(0.6875,0);c.faceVertexUvs[0][4][2]=new THREE.Vector2(0.75,0);c.faceVertexUvs[0][4][3]=new THREE.Vector2(0.75,0.375);c.faceVertexUvs[0][0][0]=new THREE.Vector2(0.75,0.375);c.faceVertexUvs[0][0][1]=new THREE.Vector2(0.75,0);c.faceVertexUvs[0][0][2]=new THREE.Vector2(0.8125,
0);c.faceVertexUvs[0][0][3]=new THREE.Vector2(0.8125,0.375);c.faceVertexUvs[0][5][0]=new THREE.Vector2(0.8125,0.375);c.faceVertexUvs[0][5][1]=new THREE.Vector2(0.8125,0);c.faceVertexUvs[0][5][2]=new THREE.Vector2(0.875,0);c.faceVertexUvs[0][5][3]=new THREE.Vector2(0.875,0.375);c.faceVertexUvs[0][2][0]=new THREE.Vector2(0.6875,0.375);c.faceVertexUvs[0][2][1]=new THREE.Vector2(0.6875,0.5);c.faceVertexUvs[0][2][2]=new THREE.Vector2(0.75,0.5);c.faceVertexUvs[0][2][3]=new THREE.Vector2(0.75,0.375);c.faceVertexUvs[0][3][0]=
new THREE.Vector2(0.75,0.375);c.faceVertexUvs[0][3][1]=new THREE.Vector2(0.75,0.5);c.faceVertexUvs[0][3][2]=new THREE.Vector2(0.8125,0.5);c.faceVertexUvs[0][3][3]=new THREE.Vector2(0.8125,0.375);a=new THREE.CubeGeometry(0.5*this._scale,1.5*this._scale,0.5*this._scale);a.faceVertexUvs[0][1][0]=new THREE.Vector2(0,0.375);a.faceVertexUvs[0][1][1]=new THREE.Vector2(0,0);a.faceVertexUvs[0][1][2]=new THREE.Vector2(0.0625,0);a.faceVertexUvs[0][1][3]=new THREE.Vector2(0.0625,0.375);a.faceVertexUvs[0][4][0]=
new THREE.Vector2(0.0625,0.375);a.faceVertexUvs[0][4][1]=new THREE.Vector2(0.0625,0);a.faceVertexUvs[0][4][2]=new THREE.Vector2(0.125,0);a.faceVertexUvs[0][4][3]=new THREE.Vector2(0.125,0.375);a.faceVertexUvs[0][0][0]=new THREE.Vector2(0.125,0.375);a.faceVertexUvs[0][0][1]=new THREE.Vector2(0.125,0);a.faceVertexUvs[0][0][2]=new THREE.Vector2(0.1875,0);a.faceVertexUvs[0][0][3]=new THREE.Vector2(0.1875,0.375);a.faceVertexUvs[0][5][0]=new THREE.Vector2(0.1875,0.375);a.faceVertexUvs[0][5][1]=new THREE.Vector2(0.1875,
0);a.faceVertexUvs[0][5][2]=new THREE.Vector2(0.25,0);a.faceVertexUvs[0][5][3]=new THREE.Vector2(0.25,0.375);a.faceVertexUvs[0][2][0]=new THREE.Vector2(0.6875,0.375);a.faceVertexUvs[0][2][1]=new THREE.Vector2(0.6875,0.5);a.faceVertexUvs[0][2][2]=new THREE.Vector2(0.75,0.5);a.faceVertexUvs[0][2][3]=new THREE.Vector2(0.75,0.375);a.faceVertexUvs[0][3][0]=new THREE.Vector2(0.75,0.375);a.faceVertexUvs[0][3][1]=new THREE.Vector2(0.75,0.5);a.faceVertexUvs[0][3][2]=new THREE.Vector2(0.8125,0.5);a.faceVertexUvs[0][3][3]=
new THREE.Vector2(0.8125,0.375);for(var g=0;8>g;g++)b.vertices[g].y+=0.5*this._scale,d.vertices[g].y+=0.5*this._scale,c.vertices[g].y-=0.5*this._scale;var k=new THREE.MeshBasicMaterial({map:e}),l=new THREE.MeshBasicMaterial({map:e,transparent:!0,side:THREE.DoubleSide}),g=new THREE.MeshBasicMaterial({map:e}),h=new THREE.MeshBasicMaterial({map:e}),e=new THREE.MeshBasicMaterial({map:e});this._helmetMesh=new THREE.Mesh(d,l);this._leftArmMesh=new THREE.Mesh(c,h);this._rightArmMesh=new THREE.Mesh(c,h);
b=new THREE.Mesh(b,k);f=new THREE.Mesh(f,g);d=new THREE.Mesh(a,e);a=new THREE.Mesh(a,e);f.position.y-=0.75*this._scale+this._scale/2;this._leftArmMesh.position.y-=this._scale/2+0.25*this._scale;this._leftArmMesh.position.x+=this._scale/4+this._scale/2;this._rightArmMesh.position.y-=this._scale/2+0.25*this._scale;this._rightArmMesh.position.x-=this._scale/4+this._scale/2;d.position.y-=1.5*this._scale+this._scale/2+0.75*this._scale;d.position.x-=0.25*this._scale;a.position.y-=1.5*this._scale+this._scale/
2+0.75*this._scale;a.position.x+=0.25*this._scale;this._playerModel=new THREE.Object3D;this._headGroup=new THREE.Object3D;this._headGroup.add(b);this._headGroup.add(this._helmetMesh);this._headGroup.position.y-=0.5*this._scale;this._playerModel.add(this._headGroup);this._playerModel.add(f);this._playerModel.add(this._leftArmMesh);this._playerModel.add(this._rightArmMesh);this._playerModel.add(d);this._playerModel.add(a);this._scene.add(this._playerModel);void 0!==this._positionVector3&&(this._playerModel.position.x+=
this._positionVector3.x,this._playerModel.position.y+=this._positionVector3.y,this._playerModel.position.z+=this._positionVector3.z)},animate:function(a,e,b,d,f,c){c=new THREE.Vector3(c.position.x-(this._positionVector3.x+this._headGroup.position.x),c.position.y-(this._positionVector3.y+this._headGroup.position.y),c.position.z-(this._positionVector3.z+this._headGroup.position.z));new THREE.Vector2(e-d/2,b-f/2);e=Math.PI/2;this._rightArmMesh.rotation.x=0.098175*Math.sin(a);this._rightArmMesh.rotation.y=
0.049087*Math.cos(a);this._rightArmMesh.rotation.z=-(0.098175+0.098175*Math.sin(a));this._leftArmMesh.rotation.x=0.098175*Math.sin(a);this._leftArmMesh.rotation.y=0.049087*Math.cos(a);this._leftArmMesh.rotation.z=0.098175+0.098175*Math.sin(a);a=Math.atan2(c.x,c.z);b=Math.atan2(c.x,-c.z);c.length();this._headGroup.rotation.y=a>=-e&&a<=e?a:b;this._helmetMesh.visible=!this._hideHelmet},showHelmet:function(){this._hideHelmet=!1},hideHelmet:function(){this._hideHelmet=!0}};
CaffeinatedRat.Minecraft.SkinProfile=function(a){if(!window.WebGLRenderingContext)throw new CaffeinatedRat.Minecraft.SkinProfile.BrowserNotSupported("constructor");CaffeinatedRat.Minecraft.SkinProfile.VERSION=new CaffeinatedRat.Version(6,0,0);console.log("CaffeinatedRat.Minecraft.SkinProfile.Version: "+CaffeinatedRat.Minecraft.SkinProfile.VERSION.toString());a=a||{};this._skinImage=void 0!==a.skinImage?a.skinImage:null;this._container=void 0!==a.container?a.container:null;this._useWebGL=void 0!==
a.useWebGL?a.useWebGL:!1;this._canvasWidth=void 0!==a.canvasWidth?a.canvasWidth:540;this._canvasHeight=void 0!==a.canvasHeight?a.canvasHeight:540;this._hideHelmet=void 0!==a.hideHelmet?a._hideHelmet:!1;this._positionVector3=void 0!==a.positionVector3?a.positionVector3:new THREE.Vector3(0,0,0);this._scale=void 0!==a.scale?a.scale:300;this._controls=this._renderer=this._scene=this._camera=null;this._tick=this._animationId=0;this._3dModel=new CaffeinatedRat.Minecraft.ComputedModel({hideHelmet:this._hideHelmet,
skinImage:this._skinImage,scale:this._scale,positionVector3:this._positionVector3});this._mousePosX=this._canvasWidth/2;this._mousePosY=this._canvasHeight/2};
CaffeinatedRat.Minecraft.SkinProfile.prototype={constructor:CaffeinatedRat.Minecraft.SkinProfile,init:function(){clearTimeout(this._animationId);this._tick=0;this._camera=new THREE.PerspectiveCamera(75,this._canvasWidth/this._canvasHeight,1,1E4);this._camera.position.z=200;this._scene=new THREE.Scene;this._3dModel.init(this._scene);var a=document.createElement("canvas");a.style.width="100%";a.style.height="100%";this._renderer=this._useWebGL?new THREE.WebGLRenderer({antialias:!1,canvas:a}):new THREE.CanvasRenderer({canvas:a});
this._renderer.setSize(this._canvasWidth,this._canvasHeight);this._renderer.setClearColor(new THREE.Color(0),0);null!=this._container&&this._container.append(this._renderer.domElement);this._controls=new THREE.TrackballControls(this._camera,a)},animate:function(){var a=this;this._tick=(this._tick+Math.PI/128)%(2*Math.PI);this._controls.update();this._animationId=requestAnimationFrame(function(){a.animate()});try{this._3dModel.animate(this._tick,this._mousePosX,this._mousePosY,this._canvasWidth,this._canvasHeight,
this._camera),null!=this._renderer&&this._renderer.render(this._scene,this._camera)}catch(e){throw this.stop(),console.log(e),new CaffeinatedRat.Minecraft.SkinProfile.BrowserNotSupported("animate");}},stop:function(){void 0!==this._animationId&&0<this._animationId&&window.cancelAnimationFrame(this._animationId)},showHelmet:function(){this._3dModel.showHelmet()},hideHelmet:function(){this._3dModel.hideHelmet()}};
CaffeinatedRat.Minecraft.SkinProfile.SceneNotDefinedException=function(a){CaffeinatedRat.Exception.call(this,"Minecraft.SkinProfile."+a,"A scene must be defined for this model.")};CaffeinatedRat.Minecraft.SkinProfile.BrowserNotSupported=function(a){CaffeinatedRat.Exception.call(this,"Minecraft.SkinProfile."+a,"This browser does not support WebGL.")};CaffeinatedRat=CaffeinatedRat||{};CaffeinatedRat.COMPARE_OP={EQUAL:0,LESS_THAN:1,GREATER_THAN:2};CaffeinatedRat.Version=function(a,e,b){this.Major=a||0;this.Minor=e||0;this.Revision=b||0};
CaffeinatedRat.Version.prototype={constructor:CaffeinatedRat.Version,toString:function(){return this.Major+"."+this.Minor+"."+this.Revision},equal:function(a){return a instanceof CaffeinatedRat.Version?a.Major===this.Major&&a.Minor===this.Minor&&a.Revision===this.Revision:!1},compare:function(a){if(a instanceof CaffeinatedRat.Version){var e=this.Major>a.Major?8:0,b=this.Major<a.Major?8:0,e=e+(this.Minor>a.Minor?4:0),b=b+(this.Minor<a.Minor?4:0),e=e+(this.Build>a.Build?2:0),b=b+(this.Build<a.Build?
2:0),e=e+(this.Revision>a.Revision?1:0),b=b+(this.Revision<a.Revision?1:0);return e===b?CaffeinatedRat.COMPARE_OP.EQUAL:e>b?CaffeinatedRat.COMPARE_OP.GREATER_THAN:CaffeinatedRat.COMPARE_OP.LESS_THAN}throw new CaffeinatedRat.Exception("compare","Argument 'version' is not a valid CaffeinatedRat.Version type.");}};CaffeinatedRat.VERSION=new CaffeinatedRat.Version(1,0,0);CaffeinatedRat.Exception=function(a,e){var b="CaffeinatedRat"+(void 0!==a?"."+a:"")+": "+e;this.toString=function(){return b}};
